package dev.shadowsoffire.apotheosis.spawn.spawner;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.world.entity.EntityType;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.item.BlockItem;

public class ApothSpawnerItem extends BlockItem
{
    public ApothSpawnerItem() {
        super(Blocks.f_50085_, new Item.Properties());
    }
    
    public String getCreatorModId(final ItemStack itemStack) {
        return "apotheosis";
    }
    
    public Component m_7626_(final ItemStack stack) {
        if (stack.m_41782_() && stack.m_41783_().m_128441_("BlockEntityTag")) {
            final CompoundTag tag = stack.m_41783_().m_128469_("BlockEntityTag");
            if (tag.m_128441_("SpawnData")) {
                final String name = tag.m_128469_("SpawnData").m_128469_("entity").m_128461_("id");
                final String key = "entity." + name.replace(':', '.');
                ChatFormatting color = ChatFormatting.WHITE;
                try {
                    final EntityType<?> t = (EntityType<?>)ForgeRegistries.ENTITY_TYPES.getValue(new ResourceLocation(name));
                    final MobCategory cat = t.m_20674_();
                    switch (cat) {
                        case CREATURE: {
                            color = ChatFormatting.DARK_GREEN;
                            break;
                        }
                        case MONSTER: {
                            color = ChatFormatting.RED;
                            break;
                        }
                        case WATER_AMBIENT:
                        case WATER_CREATURE: {
                            color = ChatFormatting.BLUE;
                            break;
                        }
                    }
                }
                catch (final Exception ex) {}
                return (Component)Component.m_237110_("item.apotheosis.spawner", new Object[] { Component.m_237115_(key) }).m_130940_(color);
            }
        }
        return super.m_7626_(stack);
    }
}
